//C++

#ifndef XSFORTRAN_H
#define XSFORTRAN_H
#include <sys/types.h>
// functions that the fortran library needs that are implemented in C++ now.
//


#ifdef __cplusplus
extern "C"
{
#endif
        char* FGMODF();
        char* FGDATD();
        float FGABND(char* element);
        char*  FGXSCT(); 
        char*  FGSOLR();
        char*  FGMSTR(char* dname);
        void FPDATD(const char* dataDir);
        void FPSOLR(const char* table, int* ierr);
        void FPXSCT(const char* csection, int* ierr);
        void FPMSTR(const char* value1, const char* value2);
        void FPSLFL(float rvalue[], int nvalue, int *ierr);
        void FNINIT();
        int xs_write(char*, int);
        int xs_read(const char*, char*, int*);
        float csmgq0();
        float csmgh0();
        float csmgl0();
        void csmpq0(float q0);
        void csmph0(float H0);
        void csmpl0(float lambda0);
        float fzsq(float z, float q0, float lambda);
        
   // These are not xspec's chatter levels.  They are intended for
   // use by other programs which link to XSFunctions.
        int FGCHAT();
        void FPCHAT(int chat);
   // This retrieves xspec's chatter levels, or 0 if not calling
   // from xspec.
        void xs_getChat(int* cons, int* log);
        
   // Interface for user C and Fortran subroutines requiring use of
   // Gamma functions in the Numerics subdirectory of the XSUtil library.
        float xs_erf( float x);
        float xs_erfc(float x);
        float gammap(float a, float x);
        float gammq(float a, float x);


   // Wrappers for C++ models w/ C interface.
   // Assumes energy points to arrays of size nFlux+1, flux and fluxError
   // point to arrays of size nFlux (though they need not be initialized),
   // and params points to an array of size nPar for the particular model.
   // initStr may point to a valid character string or it may be NULL if
   // unused.
        void C_powerLaw(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
        void C_zpowerLaw(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
        void C_cutoffPowerLaw(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
#ifdef __cplusplus                 
}
#endif

#endif
